/*  
  TimeToaster.java

  11.03.2001: tk, sourcecode released under the GPL.

  Copyright (c)2001 by SoPra2001 Gruppe 14, University of Dortmund
  mail for contact: thomas.kindler@gmx.de

  This program is free software; you can redistribute it and/or modify it 
  under the terms of the GNU General Public License as published by the 
  Free Software Foundation; either version 2 of the License, or (at your 
  option) any later version. Please read the included "copying.txt" file,
  or the full License at http://www.gnu.org/copyleft for more details.
*/

import javax.swing.UIManager;
import javax.swing.JFrame;
import java.awt.*;

import gui.*;
import logic.*;

public class TimeToaster {
  public static HauptFenster  hauptFenster;
  public static Projekt       projekt = new Projekt();

  public static void main(String[] args) throws Exception {
    try {
      UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
    }
    catch(Exception e) {
      e.printStackTrace();
    }

    /* Application Frame erzeuegen und zentrieren */
    hauptFenster = new HauptFenster( projekt );
    hauptFenster.validate();

    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize  = hauptFenster.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }

    hauptFenster.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    hauptFenster.setVisible(true);

    StartDlg startDlg = new StartDlg(hauptFenster.getRootPane(), hauptFenster );
    startDlg.show();





  }
}