/*  
  BenutzerDlg.java

  11.03.2001: tk, sourcecode released under the GPL.

  Copyright (c)2001 by SoPra2001 Gruppe 14, University of Dortmund
  mail for contact: thomas.kindler@gmx.de

  This program is free software; you can redistribute it and/or modify it 
  under the terms of the GNU General Public License as published by the 
  Free Software Foundation; either version 2 of the License, or (at your 
  option) any later version. Please read the included "copying.txt" file,
  or the full License at http://www.gnu.org/copyleft for more details.
*/

package gui;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
import logic.*;
import TimeToaster;

public class BenutzerDlg extends JDialog {
  private  JPanel panel1 = new JPanel();
  private  BorderLayout borderLayout1 = new BorderLayout();
  private  TitledBorder titledBorder1;
  private  TitledBorder titledBorder2;
  private  JPanel jPanel3 = new JPanel();
  private  JLabel jLabel9 = new JLabel();
  private  JLabel jLabel10 = new JLabel();
  private  JLabel jLabel8 = new JLabel();
  private  JPasswordField jPasswordField_Neu2 = new JPasswordField();
  private  JPanel jPanel8 = new JPanel();
  private  JPasswordField jPasswordField_Neu = new JPasswordField();
  private  JPasswordField jPasswordField_Alt = new JPasswordField();
  private  GridBagLayout gridBagLayout1 = new GridBagLayout();
  private  JScrollPane jScrollPane1 = new JScrollPane();
  private  GridBagLayout gridBagLayout2 = new GridBagLayout();
  private  JTextArea jTextArea_Kommentar = new JTextArea();
  private  JTextField jTextField_Name = new JTextField();
  private  JTextField jTextField_Vorname = new JTextField();
  private  JLabel jLabel4 = new JLabel();
  private  JLabel jLabel3 = new JLabel();
  private  JTextField jTextField_Login = new JTextField();
  private  JLabel jLabel2 = new JLabel();
  private  JLabel jLabel1 = new JLabel();
  private  JPanel jPanel2 = new JPanel();
  private  GridBagLayout gridBagLayout3 = new GridBagLayout();
  private  JPanel jPanel1 = new JPanel();
  private  JButton jButton_OK = new JButton();
  private  JButton jButton_Abbrechen = new JButton();
  private  FlowLayout flowLayout1 = new FlowLayout();

  /**
   * Das Nutzerobjekt, mit dem dieser Dialog arbeitet
   */
  private  Nutzer  nutzer;
  private  boolean userClickedOK = false;
  private  boolean darfDatenAendern;
  private  boolean darfPWAendern;
  private  boolean altesPWNotwendig;


  /**
   *  Erzeugt einen Benutzerdaten-Dialog, um die Daten
   *  fuer einen Benutzer anzuzeigen, bzw. zu veraendern.
   */
  public BenutzerDlg( JComponent parent, Nutzer nutzer,
                      boolean darfDatenAendern,
                      boolean darfPWAendern, boolean altesPWNotwendig )
  {
    super((Frame)parent.getTopLevelAncestor(), "Benutzerdetails", true);

    this.nutzer = nutzer;
    this.darfDatenAendern = darfDatenAendern;
    this.darfPWAendern    = darfPWAendern;
    this.altesPWNotwendig = altesPWNotwendig;

    jbInit();
    pack();
    setLocationRelativeTo(parent);
    getRootPane().setDefaultButton(jButton_OK);

    jTextField_Name.setText(nutzer.getName());
    jTextField_Vorname.setText(nutzer.getVorname());
    jTextField_Login.setText(nutzer.getLoginName());
    jTextArea_Kommentar.setText(nutzer.getKommentar());

    if (darfDatenAendern)  {
      jTextField_Login.setEnabled( true );
      jTextField_Name.setEnabled( true );
      jTextField_Vorname.setEnabled( true );
      jTextArea_Kommentar.setEnabled( true );
    }

    if (darfPWAendern) {
      jPasswordField_Alt.setEnabled( true );
      jPasswordField_Neu.setEnabled( true );
      jPasswordField_Neu2.setEnabled( true );
    }

  }

  public boolean userClickedOK() {
    return userClickedOK;
  }

  void jbInit() {
    titledBorder1 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,new Color(248, 254, 255),new Color(121, 124, 136)),"Passwort");
    titledBorder2 = new TitledBorder(BorderFactory.createEtchedBorder(new Color(248, 254, 255),new Color(121, 124, 136)),"Persoenliche Daten");
    panel1.setLayout(borderLayout1);
    borderLayout1.setHgap(8);

    this.setResizable(false);

    titledBorder2.setTitle("Persnliche Daten");
    jLabel9.setDisplayedMnemonic('P');
    jLabel9.setLabelFor(jPasswordField_Neu);
    jLabel9.setText("Neues Passwort");
    jLabel10.setDisplayedMnemonic('B');
    jLabel10.setLabelFor(jPasswordField_Neu2);
    jLabel10.setText("Besttigen");
    jLabel8.setDisplayedMnemonic('A');
    jLabel8.setLabelFor(jPasswordField_Alt);
    jLabel8.setText("Altes Passwort");
    jPanel8.setBorder(titledBorder1);
    jPanel8.setLayout(gridBagLayout1);
    jTextArea_Kommentar.setWrapStyleWord(true);
    jTextArea_Kommentar.setRows(2);
    jTextArea_Kommentar.setLineWrap(true);
    jTextArea_Kommentar.setEnabled(false);
    jTextField_Name.setEnabled(false);
    jTextField_Name.setColumns(20);
    jTextField_Vorname.setEnabled(false);
    jTextField_Vorname.setColumns(20);
    jLabel4.setDisplayedMnemonic('L');
    jLabel4.setLabelFor(jTextField_Login);
    jLabel4.setText("Login-Name");
    jLabel3.setDisplayedMnemonic('V');
    jLabel3.setLabelFor(jTextField_Vorname);
    jLabel3.setText("Vorname");
    jTextField_Login.setEnabled(false);
    jTextField_Login.setColumns(20);
    jLabel2.setDisplayedMnemonic('N');
    jLabel2.setLabelFor(jTextField_Name);
    jLabel2.setText("Name");
    jLabel1.setDisplayedMnemonic('K');
    jLabel1.setLabelFor(jTextArea_Kommentar);
    jLabel1.setText("Kommentar");
    jPanel2.setLayout(gridBagLayout2);
    jPanel2.setBorder(titledBorder2);
    jPanel3.setLayout(gridBagLayout3);
    jButton_OK.setText("OK");
    jButton_OK.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButton_OK_actionPerformed(e);
      }
    });
    jButton_Abbrechen.setText("Abbrechen");
    jButton_Abbrechen.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton_Abbrechen_actionPerformed(e);
      }
    });
    jPanel1.setLayout(flowLayout1);
    flowLayout1.setAlignment(FlowLayout.RIGHT);
    jPasswordField_Neu.setEnabled(false);
    jPasswordField_Neu2.setEnabled(false);
    jPasswordField_Alt.setEnabled(false);
    this.getContentPane().add(panel1, BorderLayout.CENTER);
    panel1.add(jPanel3, BorderLayout.CENTER);
    jPanel3.add(jPanel2, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.BOTH, new Insets(8, 8, 8, 8), 0, 0));
    jPanel2.add(jTextField_Login, new GridBagConstraints(1, 0, 2, 1, 1.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL, new Insets(8, 0, 8, 8), 0, 0));
    jPanel2.add(jLabel4, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(8, 8, 8, 8), 0, 0));
    jPanel2.add(jLabel3, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 8, 8, 8), 0, 0));
    jPanel2.add(jTextField_Vorname, new GridBagConstraints(1, 1, 2, 1, 1.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 8, 8), 0, 0));
    jPanel2.add(jLabel2, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 8, 16, 8), 0, 0));
    jPanel2.add(jLabel1, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 8, 8, 8), 0, 0));
    jPanel2.add(jTextField_Name, new GridBagConstraints(1, 2, 2, 1, 1.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 16, 8), 0, 0));
    jPanel2.add(jScrollPane1, new GridBagConstraints(2, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.BOTH, new Insets(0, 0, 8, 8), 0, 0));
    jScrollPane1.getViewport().add(jTextArea_Kommentar, null);
    jPanel3.add(jPanel8, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.BOTH, new Insets(0, 8, 8, 8), 0, 0));

    if (altesPWNotwendig) {
      jPanel8.add(jLabel8, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(8, 8, 8, 8), 0, 0));
      jPanel8.add(jPasswordField_Alt, new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL, new Insets(8, 0, 8, 8), 0, 0));
    }

    jPanel8.add(jLabel9, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 8, 8, 8), 0, 0));
    jPanel8.add(jPasswordField_Neu, new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 8, 8), 0, 0));
    jPanel8.add(jLabel10, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 8, 8, 8), 0, 0));
    jPanel8.add(jPasswordField_Neu2, new GridBagConstraints(1, 2, 1, 1, 1.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 8, 8), 0, 0));
    panel1.add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(jButton_OK, null);
    jPanel1.add(jButton_Abbrechen, null);
  }


  void jButton_OK_actionPerformed(ActionEvent e)
  {
    // Passwortfelder berprfen
    //
    String alt, neu, neu2;
    alt  = new String(jPasswordField_Alt.getPassword());
    neu  = new String(jPasswordField_Neu.getPassword());
    neu2 = new String(jPasswordField_Neu2.getPassword());

    if (!neu.equals("")) {
      if (altesPWNotwendig && !alt.equals(nutzer.getPasswort()))  {
        JOptionPane.showMessageDialog(
          this, "Das alte Passwort ist falsch.",
           "Fehler", JOptionPane.ERROR_MESSAGE
        );
        return;
      }
      if (!neu.equals(neu2))  {
        JOptionPane.showMessageDialog(
          this, "Die beiden Passwrter stimmen nicht berein.",
           "Fehler", JOptionPane.ERROR_MESSAGE
        );
        return;
      }
      JOptionPane.showMessageDialog(this, "Das Passwort wurde gendert." );
    }

    // Alle benutzerdaten sind validiert, nun wird versucht das
    // Benutzerobjekt tatsaechlich zu ndern. Dabei kann es zu
    // einer Exception kommen, falls der Loginname schon existiert.
    //
    try {
      nutzer.setLoginName(jTextField_Login.getText());
      nutzer.setVorname(jTextField_Vorname.getText());
      nutzer.setName(jTextField_Name.getText());
      nutzer.setKommentar(jTextArea_Kommentar.getText());
      if (!neu.equals(""))
        nutzer.setPasswd(neu);
    } catch (Exception ex) {
      JOptionPane.showMessageDialog(
        this, ex.getMessage(), "Fehler", JOptionPane.ERROR_MESSAGE
      );
      return;
    }
    userClickedOK = true;
    dispose();
  }

  void jButton_Abbrechen_actionPerformed(ActionEvent e) {
    dispose();
  }
}