/*  
  PlanungsPanel.java

  11.03.2001: tk, sourcecode released under the GPL.

  Copyright (c)2001 by SoPra2001 Gruppe 14, University of Dortmund
  mail for contact: thomas.kindler@gmx.de

  This program is free software; you can redistribute it and/or modify it 
  under the terms of the GNU General Public License as published by the 
  Free Software Foundation; either version 2 of the License, or (at your 
  option) any later version. Please read the included "copying.txt" file,
  or the full License at http://www.gnu.org/copyleft for more details.
*/

package gui;

import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;
import java.awt.event.*;
import java.util.*;
import logic.*;

public class PlanungsPanel extends JPanel {
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JPanel jPanel2 = new JPanel();
  JButton jButton_Update = new JButton();
  FlowLayout flowLayout1 = new FlowLayout();
  JScrollPane jScrollPane1 = new JScrollPane();
  JTable jTable1 = new JTable();
  JLabel jLabel_Status = new JLabel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JButton jButton_Neu = new JButton();
  JButton jButton_Aendern = new JButton();
  JButton jButton_Entfernen = new JButton();
  JLabel jLabel2 = new JLabel();
  JTextField  jTextField_Stundenlohn = new WholeNumberField ();
  JLabel jLabel3 = new JLabel();
  DefaultTableModel aufgabenModel;

  Planung planung;

  public PlanungsPanel(Projekt projekt) {
    this.planung = projekt.getPlanung();
    jbInit( projekt.getCurrentNutzer().isAdmin() );
    updateGUI();
  }

  void jbInit( boolean darfAendern ) {
    this.setLayout(borderLayout1);
    jButton_Update.setEnabled( darfAendern );
    jButton_Update.setActionCommand("Update");
    jButton_Update.setMnemonic('U');
    jButton_Update.setText("Update");
    jButton_Update.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton_Update_actionPerformed(e);
      }
    });
    jPanel2.setLayout(flowLayout1);
    flowLayout1.setAlignment(FlowLayout.RIGHT);
    jPanel1.setLayout(gridBagLayout1);
    jLabel_Status.setForeground(Color.darkGray);
    jButton_Neu.setEnabled(darfAendern);
    jButton_Neu.setMnemonic('N');
    jButton_Neu.setText("Neu");
    jButton_Neu.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButton_Neu_actionPerformed(e);
      }
    });
    jButton_Aendern.setEnabled(darfAendern);
    jButton_Aendern.setMnemonic('R');
    jButton_Aendern.setText("ndern");
    jButton_Aendern.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButton_Aendern_actionPerformed(e);
      }
    });
    jButton_Entfernen.setEnabled(darfAendern);
    jButton_Entfernen.setMnemonic('E');
    jButton_Entfernen.setText("Entfernen");
    jButton_Entfernen.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButton_Entfernen_actionPerformed(e);
      }
    });
    jLabel2.setDisplayedMnemonic('S');
    jLabel2.setLabelFor(jTextField_Stundenlohn);
    jLabel2.setText("Stundenlohn");
    jTextField_Stundenlohn.setEnabled(darfAendern);
    jTextField_Stundenlohn.setColumns(5);
    jTextField_Stundenlohn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jTextField_Stundenlohn_actionPerformed(e);
      }
    });
    jLabel3.setText("Aufgabe");
    this.add(jPanel2, BorderLayout.SOUTH);
    jPanel2.add(jLabel3, null);
    jPanel2.add(jButton_Neu, null);
    jPanel2.add(jButton_Aendern, null);
    jPanel2.add(jButton_Entfernen, null);
    jPanel2.add(jButton_Update, null);
    this.add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jScrollPane1, new GridBagConstraints(0, 0, 3, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 8, 0), -98, -232));
    jPanel1.add(jLabel_Status, new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHEAST, GridBagConstraints.NONE, new Insets(2, 0, 8, 8), 0, 0));
    jPanel1.add(jLabel2, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(2, 8, 8, 8), 0, 0));
    jPanel1.add(jTextField_Stundenlohn, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 8, 8), 0, 0));
    jScrollPane1.getViewport().add(jTable1, null);
    jTable1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  }

  void jButton_Update_actionPerformed(ActionEvent e) {
    int retval = JOptionPane.showConfirmDialog( this,
      "Mit einem Update werden die eingegeben Personen-,\n"+
      "Dauer- und Statusfelder aktualisiert, und mit dem\n"+
      "tatschlichen Projektstatus ersetzt.\n\n"+
      "Sind Sie sicher?", "Update",
      JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE
    );

    if (retval != JOptionPane.YES_OPTION)
      return;

    planung.update();
    updateGUI();
  }

  void jButton_Entfernen_actionPerformed(ActionEvent e)
  {
    int row = jTable1.getSelectedRow();
    if (row == -1)
      return;

    int retval = JOptionPane.showConfirmDialog( this,
      "Mchten sie die Aufgabe \"FooFoo\" wirklich lschen?\n"+
      "(Dabei werden alle untergeordneten Ttigkeiten und\n"+
      "Termine entfernt)\n\nSind sie sicher?",
      "Aufgabe Entfernen",
      JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE
    );

    if (retval != JOptionPane.YES_OPTION)
      return;

    Aufgabe aufgabe = planung.getAufgabeAt(row);
    planung.remAufgabe(aufgabe);
    updateGUI();
  }

  void jButton_Neu_actionPerformed(ActionEvent e)
  {
    Aufgabe aufgabe = new Aufgabe( "", 4, 1 );

    AufgabenDlg dlg = new AufgabenDlg(this, aufgabe);
    dlg.show();

    if (dlg.userClickedOK())
      try {
        planung.addAufgabe(aufgabe);
        updateGUI();
      } catch (Exception ex) {
        ex.printStackTrace();
      }
  }

  void jButton_Aendern_actionPerformed(ActionEvent e) {
    int row = jTable1.getSelectedRow();
    if (row == -1)
      return;

    AufgabenDlg dlg = new AufgabenDlg(this, planung.getAufgabeAt(row));
    dlg.show();
    if (dlg.userClickedOK())
      updateGUI();
  }

  void updateGUI()
  {
    aufgabenModel = new DefaultTableModel() {
      public boolean isCellEditable(int row, int col) { return false; }
      public Class getColumnClass(int c) {
        switch (c) {
          case 0: return TextAreaCell.class;
          case 1: return Integer.class;
          case 2: return Integer.class;
          default:
          case 3: return String.class;
        }
      }
    };
    jTable1.setModel(aufgabenModel);

    String columnNames[] = { "Aufgabe", "Personen", "Dauer", "Status" };
    aufgabenModel.setColumnIdentifiers( columnNames );
    jTable1.getColumnModel().getColumn(0).setPreferredWidth(430);
    jTable1.getColumnModel().getColumn(1).setPreferredWidth(40);
    jTable1.getColumnModel().getColumn(2).setPreferredWidth(20);
    jTable1.getColumnModel().getColumn(3).setPreferredWidth(20);

    jTextField_Stundenlohn.setText( Integer.toString(planung.getStundenlohn()) );
    jLabel_Status.setText(
      "Personenstunden: " + planung.getPersonenStunden() +
      ", Gesamtsumme: " + planung.getPersonenStunden() * planung.getStundenlohn() +
      ",- DM"
     );

    for (int i=0; i<planung.getAufgabenCount(); i++) {
      Aufgabe aufgabe = planung.getAufgabeAt(i);
      Object  row[] = {
        aufgabe.getName(),
        new Integer(aufgabe.getPersonenZahl()),
        new Integer(aufgabe.getDauer()),
        ""
      };

      switch (aufgabe.getStatus()) {
        case StatusConst.INARBEIT:  row[3] = "In Arbeit"; break;
        case StatusConst.ERLEDIGT:  row[3] = "Erledigt";  break;
        default:
        case StatusConst.GEPLANT:   row[3] = "Geplant";   break;
      }
      aufgabenModel.addRow(row);
    }
  }

  void jTextField_Stundenlohn_actionPerformed(ActionEvent e) {
    int lohn = Integer.parseInt(jTextField_Stundenlohn.getText());
    planung.setStundenlohn( lohn );
    updateGUI();
  }
}
