/*  
  TerminDlg.java

  11.03.2001: tk, sourcecode released under the GPL.

  Copyright (c)2001 by SoPra2001 Gruppe 14, University of Dortmund
  mail for contact: thomas.kindler@gmx.de

  This program is free software; you can redistribute it and/or modify it 
  under the terms of the GNU General Public License as published by the 
  Free Software Foundation; either version 2 of the License, or (at your 
  option) any later version. Please read the included "copying.txt" file,
  or the full License at http://www.gnu.org/copyleft for more details.
*/


package gui;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;
import java.awt.event.*;
import logic.*;

public class TerminDlg extends JDialog {
  JPanel panel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JButton jButton_OK = new JButton();
  JButton jButton_Abbrechen = new JButton();
  FlowLayout flowLayout1 = new FlowLayout();
  JPanel jPanel2 = new JPanel();
  JCheckBox jCheckBox_Erledigt = new JCheckBox();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JComboBox jComboBox_Taetigkeit = new JComboBox();
  JTextField jTextField_Dauer = new WholeNumberField();
  JLabel jLabel1 = new JLabel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JLabel jLabel5 = new JLabel();
  JComboBox jComboBox_Aufgabe = new JComboBox();

  /**
   * Dieser Dialog bentigt ein Termin, und ein Planungsobjekt
   */
  private Termin   termin;
  private Planung  planung;
  private boolean  userClickedOK = false;
  private boolean  darfAendern = false;

  public TerminDlg( JComponent parent, Termin termin,
                    Projekt projekt, boolean darfAendern )
  {
    super((Frame)parent.getTopLevelAncestor(), "Termindetails", true);

    this.darfAendern = darfAendern;

    jbInit();
    pack();
    setLocationRelativeTo(parent);
    getRootPane().setDefaultButton(jButton_OK);

    this.termin = termin;
    jCheckBox_Erledigt.setSelected(termin.getErledigt());
    jTextField_Dauer.setText( Integer.toString(termin.getDauer()) );

    this.planung = projekt.getPlanung();
    for (int i=0; i<planung.getAufgabenCount(); i++) {
      Aufgabe a = planung.getAufgabeAt(i);
      jComboBox_Aufgabe.addItem( a.getName() );
      if (a == termin.getAufgabe())
        jComboBox_Aufgabe.setSelectedIndex(i);
    }
    jComboBox_Aufgabe_actionPerformed(null);

    for (int i=0; i<jComboBox_Taetigkeit.getItemCount(); i++) {
      String taetigkeit = (String)jComboBox_Taetigkeit.getItemAt(i);
      if (taetigkeit.equalsIgnoreCase(termin.getTaetigkeit()) )
        jComboBox_Taetigkeit.setSelectedIndex(i);
    }
  }

  public boolean userClickedOK()
  {
    return userClickedOK;
  }


  private void jbInit()
  {
    jCheckBox_Erledigt.setText("erledigt");
    jCheckBox_Erledigt.setMnemonic('E');
    panel1.setLayout(borderLayout1);
    jButton_OK.setMnemonic('0');
    jButton_OK.setRolloverEnabled(true);
    jButton_OK.setText("OK");
    jButton_OK.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton_OK_actionPerformed(e);
      }
    });
    jButton_Abbrechen.setMnemonic('0');
    jButton_Abbrechen.setText("Abbrechen");
    jButton_Abbrechen.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton_Abbrechen_actionPerformed(e);
      }
    });
    jPanel1.setLayout(flowLayout1);
    flowLayout1.setAlignment(FlowLayout.RIGHT);
    jPanel2.setLayout(gridBagLayout1);
    jLabel3.setDisplayedMnemonic('D');
    jLabel3.setLabelFor(jTextField_Dauer);
    jLabel3.setText("Dauer");
    jLabel4.setDisplayedMnemonic('T');
    jLabel4.setLabelFor(jComboBox_Taetigkeit);
    jLabel4.setText("Ttigkeit");
    jTextField_Dauer.setColumns(3);
    jLabel1.setText("Stunden");
    this.setResizable(false);
    jLabel5.setDisplayedMnemonic('A');
    jLabel5.setLabelFor(jComboBox_Aufgabe);
    jLabel5.setText("Aufgabe");
    jComboBox_Aufgabe.setEnabled(darfAendern);
    jComboBox_Aufgabe.setToolTipText("");
    jComboBox_Aufgabe.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jComboBox_Aufgabe_actionPerformed(e);
      }
    });
    jComboBox_Taetigkeit.setEnabled(darfAendern);
    jComboBox_Taetigkeit.setToolTipText("");
    jComboBox_Taetigkeit.setEditable(true);
    getContentPane().add(panel1);
    panel1.add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(jButton_OK, null);
    jPanel1.add(jButton_Abbrechen, null);
    panel1.add(jPanel2, BorderLayout.CENTER);
    jPanel2.add(jCheckBox_Erledigt, new GridBagConstraints(3, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHEAST, GridBagConstraints.NONE, new Insets(0, 0, 8, 8), 0, 0));
    jPanel2.add(jLabel4, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(4, 8, 8, 8), 0, 0));
    jPanel2.add(jTextField_Dauer, new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(2, 0, 8, 8), 0, 0));
    jPanel2.add(jLabel3, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(4, 8, 8, 8), 0, 0));
    jPanel2.add(jLabel1, new GridBagConstraints(2, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(4, 0, 8, 8), 0, 0));
    jPanel2.add(jComboBox_Taetigkeit, new GridBagConstraints(1, 1, 3, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 8, 8), 0, 0));
    jPanel2.add(jLabel5, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(12, 8, 8, 8), 0, 0));
    jPanel2.add(jComboBox_Aufgabe, new GridBagConstraints(1, 0, 3, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL, new Insets(8, 0, 8, 8), 0, 0));

  }


  private void jButton_OK_actionPerformed(ActionEvent e)
  {
    int index = jComboBox_Aufgabe.getSelectedIndex();
    Aufgabe aufgabe  = planung.getAufgabeAt(index);
    String  taetigkeit = (String)jComboBox_Taetigkeit.getSelectedItem();

    aufgabe.addTaetigkeit( taetigkeit  );
    termin.setAufgabe( aufgabe );
    termin.setTaetigkeit( taetigkeit );
    termin.setErledigt( jCheckBox_Erledigt.isSelected() );
    termin.setDauer( Integer.parseInt(jTextField_Dauer.getText()) );

    userClickedOK = true;
    dispose();
  }


  private void jButton_Abbrechen_actionPerformed(ActionEvent e) {
    dispose();
  }


  void jComboBox_Aufgabe_actionPerformed(ActionEvent e) {
    int index = jComboBox_Aufgabe.getSelectedIndex();
    Aufgabe aufgabe = planung.getAufgabeAt(index);;

    jComboBox_Taetigkeit.removeAllItems();
    for (int i=0; i<aufgabe.getTaetigkeitenCount(); i++)
      jComboBox_Taetigkeit.addItem(aufgabe.getTaetigkeitAt(i));

  }

}