/*  
  TextAreaCell.java

  11.03.2001: tk, sourcecode released under the GPL.

  Copyright (c)2001 by SoPra2001 Gruppe 14, University of Dortmund
  mail for contact: thomas.kindler@gmx.de

  This program is free software; you can redistribute it and/or modify it 
  under the terms of the GNU General Public License as published by the 
  Free Software Foundation; either version 2 of the License, or (at your 
  option) any later version. Please read the included "copying.txt" file,
  or the full License at http://www.gnu.org/copyleft for more details.
*/



package gui;

import java.awt.Color;

public class TextAreaCell {
  String  string;
  Color   fgcolor;
  Color   bgcolor;

  public TextAreaCell() {
    this("", null, null);
  }

  public TextAreaCell(String string) {
    this(string, null, null);
  }

  public TextAreaCell(String string, Color foreground, Color background) {
    this.string  = string;
    this.fgcolor = foreground;
    this.bgcolor = background;
  }

  public void setForeground( Color c ) {
    this.fgcolor = c;
  }

  public void setBackground( Color c ) {
    this.bgcolor = c;
  }

  public Color getForeground( Color c ) {
    return fgcolor;
  }

  public Color getBackground( Color c ) {
    return bgcolor;
  }


  public void setText( String string ) {
    this.string = string;
  }

  public String getText() {
    return string;
  }

  public String toString() {
    return string;
  }

}

