/*  
  Nutzerverwaltung.java

  11.03.2001: tk, sourcecode released under the GPL.

  Copyright (c)2001 by SoPra2001 Gruppe 14, University of Dortmund
  mail for contact: thomas.kindler@gmx.de

  This program is free software; you can redistribute it and/or modify it 
  under the terms of the GNU General Public License as published by the 
  Free Software Foundation; either version 2 of the License, or (at your 
  option) any later version. Please read the included "copying.txt" file,
  or the full License at http://www.gnu.org/copyleft for more details.
*/


package logic;
import  java.io.*;
import  java.util.*;
import  java.lang.*;

public class Nutzerverwaltung implements Serializable {

  private Vector nutzerListe;


  /**
   * Initialisiert die Benutzerverwaltung, und legt
   * einen Standardbenutzer an.
   */
  public Nutzerverwaltung() {
    nutzerListe = new Vector();
  }

  /**
   * Fgt der Liste einen neuen Nutzer hinzu.
   */
  public void addNutzer(Nutzer neu)
  {
    nutzerListe.add(neu);
  }


  public Nutzer getNutzer( String loginName ) {
    Iterator iter = nutzerListe.iterator();
    while (iter.hasNext())  {
      Nutzer n = (Nutzer)iter.next();
      if (n.getLoginName().equalsIgnoreCase(loginName))
        return n;
    }
    return null;
  }


  public void remNutzer( Nutzer nutzer ) throws Exception {
    if (nutzer.isAdmin())
      throw new Exception("Der Projektleiter kann nicht gelscht werden.");

    Iterator iter = nutzerListe.iterator();
    while (iter.hasNext())
      if  (iter.next() == nutzer) {
        iter.remove();
        break;
      }
  }

  public void remNutzer( String loginName ) throws Exception {
    remNutzer(getNutzer(loginName));
  }


  public int getNutzerCount() {
    return nutzerListe.size();
  }

  public Nutzer getNutzerAt( int index ) {
    return (Nutzer)nutzerListe.get( index );
  }
}
