/*  
  Termin.java

  11.03.2001: tk, sourcecode released under the GPL.

  Copyright (c)2001 by SoPra2001 Gruppe 14, University of Dortmund
  mail for contact: thomas.kindler@gmx.de

  This program is free software; you can redistribute it and/or modify it 
  under the terms of the GNU General Public License as published by the 
  Free Software Foundation; either version 2 of the License, or (at your 
  option) any later version. Please read the included "copying.txt" file,
  or the full License at http://www.gnu.org/copyleft for more details.
*/


package logic;
import java.io.Serializable;

public class Termin implements Serializable, StatusConst {

    private  boolean  erledigt;
    private  int      dauer;
    private  Aufgabe  aufgabe;
    private  String   taetigkeit;

    public Termin(Aufgabe aufgabe, String taetigkeit, int dauer, boolean erledigt)  {
      this.aufgabe    = aufgabe;
      this.taetigkeit = taetigkeit;
      this.dauer      = dauer;
      this.erledigt   = erledigt;
    }

    public Termin() {
      this(null, null, 4, false);
    }

    public int getStatus(){
      if (!erledigt)
        return StatusConst.GEPLANT;
      else
        if (dauer <= 5)
          return StatusConst.ERLEDIGT;
        else
          return StatusConst.VERZOEGERT;
    }

    public void setErledigt(boolean erledigt) {
      this.erledigt = erledigt;
    }

    public boolean getErledigt() {
      return erledigt;
    }

    public Aufgabe getAufgabe() {
      return aufgabe;
    }

    public void setAufgabe(Aufgabe aufgabe) {
      this.aufgabe = aufgabe;
    }

    public String getTaetigkeit(){
      return taetigkeit;
    }

    public void setTaetigkeit(String taetigkeit){
      this.taetigkeit = taetigkeit;
    }

    public int  getDauer() {
      return dauer;
    }

    public void setDauer(int  dauer) {
      this.dauer=dauer;
    }
}
